/*****************************************************************************

        ErrDifBuf.cpp
        Author: Laurent de Soras, 2010

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if defined (_MSC_VER)
	#pragma warning (1 : 4130 4223 4705 4706)
	#pragma warning (4 : 4355 4786 4800)
#endif



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include	"ErrDifBuf.h"

#include	<cassert>
#include	<cstring>



/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



ErrDifBuf::ErrDifBuf (long width)
:	_buf_ptr (0)
,/*_mem ()
,*/_width (width)
,	_stride (_width + MARGIN * 2)
{
	assert (width > 0);
	const long		buf_len = _stride * NBR_LINES;
	_buf_ptr = new int16_t [buf_len];
}



ErrDifBuf::~ErrDifBuf ()
{
	delete [] _buf_ptr;
	_buf_ptr = 0;
}



void	ErrDifBuf::clear ()
{
	memset (_buf_ptr, 0, _stride * NBR_LINES * sizeof (*_buf_ptr));
	for (int k = 0; k < MARGIN; ++k)
	{
		_mem [k] = 0;
	}
}



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
