/*****************************************************************************

        ErrDifBuf.h
        Author: Laurent de Soras, 2010

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (ErrDifBuf_HEADER_INCLUDED)
#define	ErrDifBuf_HEADER_INCLUDED

#if defined (_MSC_VER)
	#pragma once
	#pragma warning (4 : 4250)
#endif



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include	"types.h"



class ErrDifBuf
{

/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

public:

	enum {			NBR_LINES	= 2	};
	enum {			MARGIN		= 2	};

	explicit			ErrDifBuf (long width);
	virtual			~ErrDifBuf ();

	void				clear ();
	inline int16_t *
						get_buf (int ofy);
	inline int16_t &
						use_mem (int pos);
	inline const int16_t &
						use_mem (int pos) const;



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

protected:



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

	int16_t *		_buf_ptr;	// Currently not aligned with anything
	int16_t			_mem [MARGIN];
	long				_width;
	long				_stride;



/*\\\ FORBIDDEN MEMBER FUNCTIONS \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

						ErrDifBuf ();
						ErrDifBuf (const ErrDifBuf &other);
	ErrDifBuf &		operator = (const ErrDifBuf &other);
	bool				operator == (const ErrDifBuf &other) const;
	bool				operator != (const ErrDifBuf &other) const;

};	// class ErrDifBuf



#include	"ErrDifBuf.hpp"



#endif	// ErrDifBuf_HEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
