/*****************************************************************************

        ErrDifBuf.hpp
        Author: Laurent de Soras, 2010

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (ErrDifBuf_CODEHEADER_INCLUDED)
#define	ErrDifBuf_CODEHEADER_INCLUDED



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include	<cassert>



/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



int16_t *	ErrDifBuf::get_buf (int ofy)
{
	assert (ofy >= 0);
	assert (ofy < NBR_LINES);

	return (_buf_ptr + ofy * _stride + MARGIN);
}



int16_t &	ErrDifBuf::use_mem (int pos)
{
	assert (pos >= 0);
	assert (pos < MARGIN);

	return (_mem [pos]);
}



const int16_t&	ErrDifBuf::use_mem (int pos) const
{
	assert (pos >= 0);
	assert (pos < MARGIN);

	return (_mem [pos]);
}



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



#endif	// ErrDifBuf_CODEHEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
