/*****************************************************************************

        Scaler.hpp
        Author: Laurent de Soras, 2011

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (Scaler_CODEHEADER_INCLUDED)
#define	Scaler_CODEHEADER_INCLUDED



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include	<cstddef>



/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



template <class T>
void	Scaler::Ptr1 <T>::jump (Type &ptr, int stride)
{
	ptr += stride;
}

template <class T>
bool	Scaler::Ptr1 <T>::check_ptr (const Type &ptr, int align)
{
	const ptrdiff_t		x = reinterpret_cast <ptrdiff_t> (ptr);

	return (x != 0 && (x & (align - 1)) == 0);
}



template <class T>
void	Scaler::Ptr2 <T>::jump (Type &ptr, int stride)
{
	ptr._msb_ptr += stride;
	ptr._lsb_ptr += stride;
}

template <class T>
bool	Scaler::Ptr2 <T>::check_ptr (const Type &ptr, int align)
{
	const ptrdiff_t		xm = reinterpret_cast <ptrdiff_t> (ptr._msb_ptr);
	const ptrdiff_t		xl = reinterpret_cast <ptrdiff_t> (ptr._lsb_ptr);

	return (   xm != 0 && (xm & (align - 1)) == 0
	        && xl != 0 && (xl & (align - 1)) == 0);
}



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



#endif	// Scaler_CODEHEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
